﻿local localEvent = {}
localEvent.active = false
localEvent.access = false
localEvent.position = {0, 0, 0}

-- LOAD ADMIN RIGHTS

function loadEventsRights(_, playeraccount)
	if (playeraccount) then
		if isObjectInACLGroup("user." .. getAccountName(playeraccount), aclGetGroup("Developer")) or isObjectInACLGroup("user." .. getAccountName(playeraccount), aclGetGroup("Admin_4_lvl")) or isObjectInACLGroup("user." .. getAccountName(playeraccount), aclGetGroup("Admin_5_lvl")) or isObjectInACLGroup("user." .. getAccountName(playeraccount), aclGetGroup("Admin_6_lvl")) or isObjectInACLGroup("user." .. getAccountName(playeraccount), aclGetGroup("Admin")) then
			setElementData(source, "events.isAdmin", true)
		end
	end
end
addEventHandler("onPlayerLogin", getRootElement(), loadEventsRights)

-- CORE

function createEventPoint(player)
if getElementData(player, "events.isAdmin") ~= true then return end
	if (localEvent.active == true) then
		outputChatBox("Мероприятие уже создано!", player, 255, 0, 0)
		return
	end
	localEvent.position[1], localEvent.position[2], localEvent.position[3] = getElementPosition(player)
	localEvent.active = true
	outputChatBox("Администратор "..getPlayerName(player).." создал точку для проведения мероприятий.", root, 90, 227, 100)
end
addCommandHandler("createmp", createEventPoint)

function destroyEventPoint(player)
if getElementData(player, "events.isAdmin") ~= true then return end
	if (localEvent.active == false) then
		outputChatBox("Мероприятие не создано!", player, 255, 0, 0)
		return
	end
	localEvent.active = false
	localEvent.position[1], localEvent.position[2], localEvent.position[3] = 0, 0, 0
	for i, eventPlayers in ipairs(getElementsByType("player")) do
		local eventPosTable = getElementData(eventPlayers, "events.previousPosition")
		if (eventPosTable) then
			setElementPosition(eventPlayers, eventPosTable[1], eventPosTable[2], eventPosTable[3])
			setElementData(eventPlayers, "events.previousPosition", false)
		end
	end
	outputChatBox("Администратор "..getPlayerName(player).." удалил точку проведения мероприятий.", root, 255, 0, 0)
end
addCommandHandler("destroymp", destroyEventPoint)

function giveEventAccess(player)
if getElementData(player, "events.isAdmin") ~= true then return end
	if (localEvent.active == false) then
		outputChatBox("Мероприятие не создано!", player, 255, 0, 0)
		return
	end
	if (localEvent.access == true) then
		outputChatBox("Телепорт уже открыт!", player, 255, 0, 0)
		return
	end
	localEvent.access = true
	outputChatBox("Администратор "..getPlayerName(player).." открыл телепорт на мероприятие. Чтобы телепортироваться, введите: #5CC54E/tpmp#F0F07B.", root, 240, 240, 123, true)
end
addCommandHandler("truetpmp", giveEventAccess)

function removeEventAccess(player)
if getElementData(player, "events.isAdmin") ~= true then return end
	if (localEvent.active == false) then
		outputChatBox("Мероприятие не создано!", player, 255, 0, 0)
		return
	end
	if (localEvent.access == false) then
		outputChatBox("Телепорт на мероприятия закрыт!", player, 255, 0, 0)
		return
	end
	localEvent.access = false
	outputChatBox("Администратор "..getPlayerName(player).." закрыл телепорт на мероприятия. Телепорт #FF0000ЗАПРЕЩЕН#F0F07B.", root, 240, 240, 123, true)
end
addCommandHandler("falsetpmp", removeEventAccess)

function teleportToEvent(player)
	if (localEvent.access == false) then
		outputChatBox("Телепорт на мероприятие закрыт!", player, 255, 0, 0)
		return
	end
	removePedFromVehicle(source)
	local posTable = {0, 0, 0}
	posTable[1], posTable[2], posTable[3] = getElementPosition(player)
	setElementData(player, "events.previousPosition", posTable)
	setElementPosition(player, localEvent.position[1], localEvent.position[2], localEvent.position[3])
	outputChatBox("Вы были телепортированы на проведение мероприятия. После окончания его вы будете телепортированы в прежнее место.", player, 0, 255, 0)
end
addCommandHandler("tpmp", teleportToEvent)