local acl = { label = {}, button = {}, window = {}, gridlist = {}, combobox = {}, edit = {} }

function createMainMenu ()
    if isElement( acl.window[1] ) then
	    destroyElement( acl.window[1] )
		showCursor( false )
		guiSetInputMode("allow_binds")
		return
	end
	
	acl.window[1] = guiCreateWindow(.3, .32, .39, .42, "", true)
	guiWindowSetMovable(acl.window[1], false)
	guiWindowSetSizable(acl.window[1], false)

	acl.gridlist[1] = guiCreateGridList(.03, .24, .47, .58, true, acl.window[1])
	guiGridListAddColumn(acl.gridlist[1], "Игроки", 0.9)
	
	for id, player in ipairs(getElementsByType("player")) do
		local row = guiGridListAddRow ( acl.gridlist[1] )
		guiGridListSetItemText ( acl.gridlist[1], row, 1, string.gsub(getPlayerName(player), '#%x%x%x%x%x%x', '' ), false, false )
		guiGridListSetItemData(  acl.gridlist[1], row, 1, getPlayerName(player))
	end
	
	acl.combobox[1] = guiCreateComboBox(.53, .26, .28, .6, "Выберите категорию", true, acl.window[1])
	
	for i, item in ipairs ( comboBoxItems ) do
        guiComboBoxAddItem(acl.combobox[1], item)
	end
	
	acl.label[1] = guiCreateLabel(.53, .18, .28, .06, "Категории", true, acl.window[1])
	acl.label[2] = guiCreateLabel(.03, .07, .47, .16, "Выберите игрока\nили\nВведите логин", true, acl.window[1])
	--acl.label[2] = guiCreateLabel(0.65, 0.08, 0.28, 0.07, "Стоит в категориях:", true, acl.window[1])
	--acl.label[3] = guiCreateLabel(0.65, 0.18, 0.28, 0.61, "Стоит в категориях:", true, acl.window[1])

	acl.button[1] = guiCreateButton(.71, .73, .27, .09, "Выдать привелегию", true, acl.window[1])
    acl.button[2] = guiCreateButton(.93, .07, .05, .09, "Х", true, acl.window[1])
	acl.button[3] = guiCreateButton(.71, .84, .27, .09, "Отобрать привелегию", true, acl.window[1])
	
	acl.edit[1] = guiCreateEdit(.03, .86, .47, .08, "", true, acl.window[1])    

    for i = 1, 3 do
	    if isElement( acl.label[i] ) then
		    guiSetFont(acl.label[i], "default-bold-small")
            guiLabelSetHorizontalAlign(acl.label[i], "center", false)
            guiLabelSetVerticalAlign(acl.label[i], "center")
		end
		if isElement( acl.button[i] ) then
		    guiSetProperty(acl.button[i], "NormalTextColour", "FFAAAAAA")    
		end
	end
	
	showCursor( true )
	guiSetInputMode("no_binds")
end

function onClientGUIClick ()
    if source == acl.button[1] then
	    local row, column = guiGridListGetSelectedItem( acl.gridlist[1] )
	    local playerName = guiGridListGetItemData( acl.gridlist[1], row, column )
		local item = guiComboBoxGetItemText( acl.combobox[1], guiComboBoxGetSelected( acl.combobox[1] ) )
		local login = guiGetText( acl.edit[1] )
		
		if item == "Выберите категорию" then
		    outputChatBox("Категория не выбрана!", 255, 0, 0)
			return
		end
		
		if playerName then
			triggerServerEvent("setPlayerAclCategory", localPlayer, getPlayerFromName( playerName ), item)
		elseif utf8.gsub(login, " ", "") ~= "" then
		    triggerServerEvent("setPlayerAclCategoryOgin", localPlayer, login, item)
		else
		    outputChatBox("Игрок не выбран!", 255, 0, 0)
		end
	elseif source == acl.button[2] then
	    createMainMenu ()
	elseif source == acl.button[3] then
	    local row, column = guiGridListGetSelectedItem( acl.gridlist[1] )
	    local playerName = guiGridListGetItemData( acl.gridlist[1], row, column )
		local item = guiComboBoxGetItemText( acl.combobox[1], guiComboBoxGetSelected( acl.combobox[1] ) )
		local login = guiGetText( acl.edit[1] )
		
		if item == "Выберите категорию" then
		    outputChatBox("Категория не выбрана!", 255, 0, 0)
			return
		end
		
		if playerName then
			triggerServerEvent("removePlayerAclCategory", localPlayer, getPlayerFromName( playerName ), item)
		elseif utf8.gsub(login, " ", "") ~= "" then
		    triggerServerEvent("removePlayerAclCategoryOgin", localPlayer, login, item)
		else
		    outputChatBox("Игрок не выбран!", 255, 0, 0)
		end
		
	end
end
addEventHandler("onClientGUIClick", getRootElement(), onClientGUIClick)

function onPlayerOpenMenu ()
    createMainMenu ()
end
addEvent("onPlayerOpenMenu", true)
addEventHandler("onPlayerOpenMenu", getRootElement(), onPlayerOpenMenu)